import numpy as np
import matplotlib.pyplot as plt
from supportFunctions import get_all_data
import tkinter as tk
from tkinter import filedialog
import os
import h5py




# Defining the custom colormap
clmap = np.array([
    [0, 0, 0.6667],
    [0, 0, 1.0000],
    [0, 0.3333, 1.0000],
    [0, 0.6667, 1.0000],
    [0, 1.0000, 1.0000],
    [0.3333, 1.0000, 0.6667],
    [0.6667, 1.0000, 0.3333],
    [1.0000, 1.0000, 0],
    [1.0000, 0.6667, 0],
    [1.0000, 0.3333, 0]
])

# Get the current directory
current_dir = os.getcwd()

# Path to open the file dialog window in the data branch
path_folder_data = os.path.abspath(os.path.join(current_dir, "..", ".."))
path_folder_data = os.path.join(path_folder_data, "data")

# Select H5 dataset file
root = tk.Tk()
root.withdraw()
filename = filedialog.askopenfilename(initialdir=path_folder_data)


str='/DATA/unit_01/condition_01'  # it can be 'unit_XX', 'unit_XX/condition_YY' or 'unit_XX/condition_YY/trial_ZZ'

spikes, markers, all_strings = get_all_data.get_all_data_from_level_h5(filename, str)

str2readmk = '/DATA/unit_01/condition_01/trial_01/events_markers'

with h5py.File(filename, 'r') as f:
    marker_labels = f[str2readmk].attrs['Marker labels']

count = 1
fig, ax = plt.subplots()
first_iteration = True   
for spike_data, marker_data in zip(spikes, markers):

    ax.scatter(spike_data, np.ones_like(spike_data) * count, marker='|', color='k')
    sz = 30

    for mk in range(marker_data.size):
        cc = clmap[mk]

        if first_iteration:
            ax.scatter(marker_data[mk], np.ones_like(marker_data[mk]) * count,
                       s=sz, color=cc, marker='o', edgecolors=cc, label=marker_labels[mk])
        else:
            ax.scatter(marker_data[mk], np.ones_like(marker_data[mk]) * count,
                       s=sz, color=cc, marker='o', edgecolors=cc)


    count = count + 1
    first_iteration= False

ax.set_ylim([0.5, count ])
ax.set_xlabel('Time (ms)')
ax.set_ylabel('Trial #')
ax.legend()
ax.set_title('Raster Plot')
plt.show()